/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package myuniversityproject20082009;
/**
 *
 * @author CHIHAOUI
 */
public class DataFile implements InterfaceDataFile{

    /**
     * Converts the file in the parameter to list 
     * @param fileName URL of the file
     * @return list of object in the file
     */
    public java.util.List convertFileToList(String fileName)throws ExceptionUniversity {
        java.util.List list = new java.util.LinkedList();
        try {
            java.io.FileInputStream myDataFile = new java.io.FileInputStream(fileName + ".dat");
            java.io.ObjectInputStream objectReader = new java.io.ObjectInputStream(myDataFile);
            while (myDataFile.available() > 0) {
                list.add(objectReader.readObject());
            }
            myDataFile.close();
        } catch (Exception ex) {
            throw new ExceptionUniversity("File Or Directory Not Found We Will Create An Empty File !!");
        }
        return list;
    }

    /**
     * Fills the file from objects in the list
     * @param list list of the objects
     * @param fileName URL of the file
     */
    public void convertListToFile(java.util.List list,String fileName) throws ExceptionUniversity{
        try{
            java.io.FileOutputStream myDataFile=new java.io.FileOutputStream(fileName+".dat");
            java.io.ObjectOutputStream objectWriter=new java.io.ObjectOutputStream(myDataFile);
            java.util.Iterator i=list.iterator();
            while(i.hasNext()){
                objectWriter.writeObject(i.next());
            }
            myDataFile.flush();
            myDataFile.close();
        }catch(Exception ex){
            throw new ExceptionUniversity("File Or Directory Not Found We Will Create An Empty File !!");
        }
    }

    
    /**
     * Adds an object to the file
     * @param fileName URL of the file
     * @param obj Object to add to the file
     */
    public void addData(String fileName,Object obj){
        try{
            java.io.FileOutputStream myDataFile=new java.io.FileOutputStream(fileName+".dat");
            java.io.ObjectOutputStream objectWriter=new java.io.ObjectOutputStream(myDataFile);
                objectWriter.writeObject(obj);
            myDataFile.flush();
            myDataFile.close();
        }catch(java.io.IOException ex){
            ex.printStackTrace();
        }
    }
    
    /**
     * copy the fileName to fileDest
     * @param fileName the source file
     * @param fileDest the destination file
     */
    public void copyFile(java.io.File fileName,java.io.File fileDest){
        try{
        if(fileName.exists()){
                java.io.FileOutputStream fos=new java.io.FileOutputStream(fileDest);
                java.io.FileInputStream fis=new java.io.FileInputStream(fileName);
                byte[] octal=new byte[1000000];
                fis.read(octal);
                fos.write(octal);
        }
        }catch(Exception ex){
            ex.printStackTrace();
        }
    }

}
