/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package myuniversityproject20082009;

/**
 *
 * @author CHIHAOUI
 */
public class Institutes extends java.util.TreeSet<Institute> implements InterfaceInstitutes,java.io.Serializable{

    public Institutes(){
        
    }
    /**
     * 
     * @return the number of institute in the List Of Institutes
     */
    public int getSize() {
        return super.size();
    }

    /**
     * 
     * @return true if the List Of Institutes is empty, false if not
     */
    @Override
    public boolean isEmpty() {
        return super.isEmpty();
    }

    /**
     * 
     * @param institute add institute to the List Of Institutes
     */
    public boolean addInstitute(Institute institute) {
        return super.add(institute);
    }

    /**
     * 
     * @param code the code of institute
     * @return the institute having the code in param
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public Institute getInstitute(int code) throws ExceptionUniversity {
        java.util.Iterator i = this.iterator();
        while (i.hasNext()) {
            Institute institute = (Institute) i.next();
            if (institute.getCode() == code) {
                return institute;
            }
        }
        throw new ExceptionUniversity("The Code Is Invalid");
    }

    /**
     * 
     * @param code the code of institute to search for
     * @param code2 the new code to affect
     * @param name the new name to affect
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public void setInstitute(int code, int code2, String name) throws ExceptionUniversity {
        java.util.Iterator i = super.iterator();
        boolean find = false;
        Institute institute = null;
        while ((i.hasNext()) && (!find)) {
            institute = (Institute) i.next();
            if (institute.getCode() == code) {
                find = true;
            }
        }
        if (find) {
            institute.setName(name);
            institute.setCode(code2);
        } else {
            throw new ExceptionUniversity("The Code Is Invalid");
        }
    }

    /**
     * 
     * @param code code of the institute
     * @return true if the associated institute to the code is in the List Of Institutes
     */
    public boolean isExist(int code) {
        java.util.Iterator i = super.iterator();
        boolean find = false;
        while ((i.hasNext()) && (!find)) {
            Institute institute = (Institute) i.next();
            if (institute.getCode() == code) {
                find = true;
            }
        }
        if (!find) {
            return false;
        } else {
            return true;
        }
    }

    /**
     * 
     * @param code delete the institute having thye associated code
     * @throws myuniversityproject20082009.ExceptionUniversity if the institute having the code doesn't exist
     */
    public void delete(int code) throws ExceptionUniversity {
        java.util.Iterator i = super.iterator();
        boolean find = false;
        Institute institute;
        while ((i.hasNext()) && (!find)) {
            institute = (Institute) i.next();
            if (institute.getCode() == code) {
                find = true;
            }
        }
        if (find) {
            i.remove();
        } else {
            throw new ExceptionUniversity("The Code Is Invalid");
        }
    }

    /**
     * 
     * @return the List Of Institutes as String
     */
    @Override
    public String toString() {
        String ch="";
        java.util.Iterator i = super.iterator();
        Institute institute;
        while (i.hasNext()) {
            institute = (Institute) i.next();
            ch=ch+" "+institute;
        }
        return ch;
    }
}
