/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package myuniversityproject20082009;

/**
 *
 * @author CHIHAOUI
 */
public interface InterfaceDataBase {
    
    /**
     * execute query in parameter
     * @param query the query to do
     * @throws myuniversityproject20082009.ExceptionUniversity if the syntax of the query is not correct
     */
    public void executeQuery(String query) throws ExceptionUniversity;
    
    /**
     * return the Object having rowIndex and columnIndex
     * @param rowIndex the index of the row
     * @param columnIndex the index of the column
     * @return the Object having rowIndex and columnIndex
     */
    public Object getValueAt(int rowIndex, int columnIndex);

    /**
     * return the numbre of the columns
     * @return the numbre of the columns
     */
    public int getColumnCount() ;

    /**
     * return the numbre of the rows
     * @return the numbre of the rows
     */
    public int getRowCount() ;
    
    /**
     * closing all modifiers
     * @throws java.sql.SQLException
     */
    public void close();
    
    /**
     * return the column name having the column in parameter
     * @param column the index of the column
     * @return the column name having the column in parameter
     */
    public String getColumnName(int column);
}
