/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package myuniversityproject20082009;

/**
 *
 * @author CHIHAOUI
 */
public interface InterfaceInstitutes{
    /**
     * 
     * @return the number of institute in the List Of Institutes
     */
    public int getSize() ;

    /**
     * 
     * @return true if the List Of Institutes is empty, false if not
     */
    public boolean isEmpty() ;

    /**
     * 
     * @param institute add institute to the List Of Institutes
     */
    public boolean addInstitute(Institute institute);

    /**
     * 
     * @param code the code of institute
     * @return the institute having the code in param
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public Institute getInstitute(int code) throws ExceptionUniversity ;

    /**
     * 
     * @param code the code of institute to search for
     * @param code2 the new code to affect
     * @param name the new name to affect
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public void setInstitute(int code, int code2, String name) throws ExceptionUniversity ;

    /**
     * 
     * @param code code of the institute
     * @return true if the associated institute to the code is in the List Of Institutes
     */
    public boolean isExist(int code);

    /**
     * 
     * @param code delete the institute having thye associated code
     * @throws myuniversityproject20082009.ExceptionUniversity if the institute having the code doesn't exist
     */
    public void delete(int code) throws ExceptionUniversity ;

    /**
     * 
     * @return the List Of Institutes as String
     */
    @Override
    public String toString();
}
