/*
 * Person.java
 *
 * Created on 16 novembre 2008, 10:41
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package myuniversityproject20082009;

/**
 *
 * @author CHIHAOUI
 */
public abstract class Person implements InterfacePerson, java.io.Serializable,java.lang.Comparable<Person> {

    /** fields**/
    private InterfaceCode interfaceCode;
    private InterfaceName interfaceName;
    private InterfaceAge interfaceAge;

    /**
     * create a new Person
     */
    public Person(){
        interfaceCode=new Code();
        interfaceName=new Name();
        interfaceAge=new Age();
    }
    
    /**
     * create new person
     * @param code code of the person as Integer
     * @param name name of the Person as String
     */
    public Person(int code,String name,int age){
        interfaceCode=new Code(code);
        interfaceName=new Name(name);
        interfaceAge=new Age(age);
    }
    
   /** 
     * 
     * @return the code
     */
    public int getCode(){
        return this.interfaceCode.getCode();
    }
    /**
     * 
     * @return the age of the person
     */
    public int getAge(){
        return this.interfaceAge.getAge();
    }
    
    /**
     * get method
     * @return the name
     */
    public String getName(){
        return this.interfaceName.getName();
    }
    /**
     * setting code
     * @param code the new code
     */
    public void setCode(int code){
        this.interfaceCode.setCode(code);
    }
    
    /**
     * setting age
     * @param age the new age
     */
    
    public void setAge(int age){
        this.interfaceAge.setAge(age);
    }
    
    /**
     * set method
     * @param name : name of student
     */
    public void setName(String name){
        this.interfaceName.setName(name);
    }

    /**
     * 
     * @param object : it's an Object but instanciated with Person
     * @return true if object have the same code as this
     * false if not
     */
    @Override
    public boolean equals(Object object){
        return ((Person)object).getCode()==this.getCode()?true:false;
    }

    @Override
    public int hashCode() {
        int hash = 3;
        return hash;
    }
    
    /**
     * compare two person by code
     * @param person
     * @return 1 if the code of this > the code of person,0 if the same,-1 if the the code of this < the code of person
     */
    public int compareTo(Person person){
        if(this.getCode()>person.getCode())
            return 1;
        else
            if(this.getCode()==person.getCode())
                return 0;
            else
                return -1;
    }
    
    /**
     * 
     * @return the object as String
     */
    @Override
    public String toString(){
        return "the name of the person is : "+this.getName()+" the associated code is : "+this.getCode();
    }
    
    /**
     * 
     * @return the function of the person
     */
    public abstract String getFunction();
}
