/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package myuniversityproject20082009;

/**
 *
 * @author CHIHAOUI
 */
public class Teachers extends java.util.TreeSet<Teacher> implements InterfaceTeachers, java.io.Serializable {
    
    
    public Teachers(){
        super();
    }
    /**
     * 
     * @return the number of teacher in the Collection Of Teachers
     */
    public int getSize() {
        return super.size();
    }

    /**
     * 
     * @return true if the Collection Of Teachers is empty, false if not
     */
    @Override
    public boolean isEmpty() {
        return super.isEmpty();
    }

    /**
     * 
     * @param teacher add teacher to the Collection Of Teachers
     */
    public boolean addTeacher(Teacher teacher) {
        return super.add(teacher);
    }

    /**
     * 
     * @param code the code of teacher
     * @return the teacher having the code in param
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public Teacher getTeacher(int code) throws ExceptionUniversity {
        java.util.Iterator i = this.iterator();
        while (i.hasNext()) {
            Teacher teacher = (Teacher) i.next();
            if (teacher.getCode() == code) {
                return teacher;
            }
        }
        throw new ExceptionUniversity("The Code Is Invalid");
    }
    public Teacher getTeacher(String name) throws ExceptionUniversity {
        java.util.Iterator i = this.iterator();
        while (i.hasNext()) {
            Teacher teacher = (Teacher) i.next();
            if (teacher.getName().equalsIgnoreCase(name)) {
                return teacher;
            }
        }
        throw new ExceptionUniversity("The Name Is Invalid");
    }
    /**
     * 
     * @param code the code of teacher to search for
     * @param code2 the new code to affect
     * @param name the new name to affect
     * @param age the new age to affect
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public void setTeacher(int code, int code2, String name, int age) throws ExceptionUniversity {
        java.util.Iterator i = super.iterator();
        boolean find = false;
        Teacher teacher = null;
        while ((i.hasNext()) && (!find)) {
            teacher = (Teacher) i.next();
            if (teacher.getCode() == code) {
                find = true;
            }
        }
        if (find) {
            teacher.setName(name);
            teacher.setAge(age);
            teacher.setCode(code2);
        } else {
            throw new ExceptionUniversity("The Code Is Invalid");
        }
    }

    /**
     * 
     * @param code code of the teacher
     * @return true if the associated teacher to the code is in the Collection Of Teachers
     */
    public boolean isExist(int code) {
        java.util.Iterator i = super.iterator();
        boolean find = false;
        while ((i.hasNext()) && (!find)) {
            Teacher teacher = (Teacher) i.next();
            if (teacher.getCode() == code) {
                find = true;
            }
        }
        if (!find) {
            return false;
        } else {
            return true;
        }
    }

    /**
     * 
     * @param code delete the teacher having thye associated code
     * @throws myuniversityproject20082009.ExceptionUniversity if the teacher having the code doesn't exist
     */
    public void delete(int code) throws ExceptionUniversity {
        java.util.Iterator i = super.iterator();
        boolean find = false;
        Teacher teacher;
        while ((i.hasNext()) && (!find)) {
            teacher = (Teacher) i.next();
            if (teacher.getCode() == code) {
                find = true;
            }
        }
        if (find) {
            i.remove();
        } else {
            throw new ExceptionUniversity("The Code Is Invalid");
        }
    }

    /**
     * 
     * @return the Collection Of Teachers as String
     */
    @Override
    public String toString() {
        String ch="";
        java.util.Iterator i = super.iterator();
        Teacher teacher;
        while (i.hasNext()) {
            teacher = (Teacher) i.next();
            ch=ch+" "+teacher;
        }
        return ch;
    }
}
