/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package myuniversityproject20082009;

/**
 *
 * @author CHIHAOUI
 */
public interface InterfaceInstitute {

    /**
     * 
     * @return the code of the institute
     */
    public int getCode() ;

    /**
     * 
     * @param code the new code to affect
     */
    public void setCode(int code) ;
    
    /**
     * 
     * @return the name of the institute
     */
    public String getName() ;

    /**
     * 
     * @param name the new name to affect
     */
    public void setName(String name);
    
    /**
     * 
     * @return the number of student in the List Of Students
     */
    public int getNumberStudents();

    /**
     * 
     * @return true if the List Of Students is empty, false if not
     */
    public boolean isSetStudentIsEmpty();

    /**
     * 
     * @param student add student to the List Of Students
     */
    public boolean addStudent(Student student);

    /**
     * 
     * @param code the code of student
     * @return the student having the code in param
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public Student getStudent(int code) throws ExceptionUniversity;

    /**
     * 
     * @param code the code of student to search for
     * @param code2 the new code to affect
     * @param name the new name to affect
     * @param age the new age to affect
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public void setStudent(int code, int code2, String name, int age) throws ExceptionUniversity;

    /**
     * 
     * @param code code of the student
     * @return true if the associated student to the code is in the List Of Students
     */
    public boolean isExistStudent(int code);

    /**
     * 
     * @param code delete the student having thye associated code
     * @throws myuniversityproject20082009.ExceptionUniversity if the student having the code doesn't exist
     */
    public void deleteStudent(int code) throws ExceptionUniversity;

    /**
     * 
     * @return the List Of Students as String
     */
    public String toStringStudents();

    /**
     * 
     * @return the number of teacher in the Collection Of Teachers
     */
    public int getSizeTeachers();

    /**
     * 
     * @return true if the Collection Of Teachers is empty, false if not
     */
    public boolean isSetTeacherIsEmpty();

    /**
     * 
     * @param teacher add teacher to the Collection Of Teachers
     */
    public boolean addTeacher(Teacher teacher);

    /**
     * 
     * @param code the code of teacher
     * @return the teacher having the code in param
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public Teacher getTeacher(int code) throws ExceptionUniversity;

    /**
     * 
     * @param code the code of teacher to search for
     * @param code2 the new code to affect
     * @param name the new name to affect
     * @param age the new age to affect
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public void setTeacher(int code, int code2, String name, int age) throws ExceptionUniversity;

    /**
     * 
     * @param code code of the teacher
     * @return true if the associated teacher to the code is in the Collection Of Teachers
     */
    public boolean isExistTeacher(int code);

    /**
     * 
     * @param code delete the teacher having thye associated code
     * @throws myuniversityproject20082009.ExceptionUniversity if the teacher having the code doesn't exist
     */
    public void deleteTeacher(int code) throws ExceptionUniversity;

    /**
     * 
     * @return the Collection Of Teachers as String
     */
    public String toStringTeachers();

    public int compareTo(Institute institute);
    @Override
    public String toString();
}
