/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package myuniversityproject20082009;

/**
 *
 * @author CHIHAOUI
 */
public interface InterfaceStudents {

    /**
     * 
     * @return the number of student in the List Of Students
     */
    public int getSize();

    /**
     * 
     * @return true if the List Of Students is empty, false if not
     */
    public boolean isEmpty();

    /**
     * 
     * @param student add student to the List Of Students
     * @return true if the student is unique, false if he already exists
     */
    public boolean addStudent(Student student);

    /**
     * 
     * @param code the code of student to search for
     * @param code2 the new code to affect
     * @param name the new name to affect
     * @param age the new age to affect
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public void setStudent(int code, int code2, String name, int age) throws ExceptionUniversity;

    /**
     * 
     * @param code the code of student
     * @return the student having the code in param
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public Student getStudent(int code) throws ExceptionUniversity;

    public Student getStudent(String name) throws ExceptionUniversity;
    
    /**
     * 
     * @param code code of the student
     * @return true if the associated student to the code is in the List Of Students
     */
    public boolean isExist(int code);

    /**
     * 
     * @param code delete the student having thye associated code
     * @throws myuniversityproject20082009.ExceptionUniversity if the student having the code doesn't exist
     */
    public void delete(int code) throws ExceptionUniversity;

    /**
     * 
     * @return the Group as String
     */
    @Override
    public String toString();
}
