/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package myuniversityproject20082009;

/**
 *
 * @author CHIHAOUI
 */
public interface InterfaceTeachers {

    /**
     * 
     * @return the number of teacher in the Collection Of Teachers
     */
    
    public int getSize();

    /**
     * 
     * @return true if the Collection Of Teachers is empty, false if not
     */
    public boolean isEmpty();

    /**
     * 
     * @param teacher add teacher to the Collection Of Teachers
     * @return true if the teacher is unique, false if he already exists
     */
    public boolean addTeacher(Teacher teacher);

    /**
     * 
     * @param code the code of teacher to search for
     * @param code2 the new code to affect
     * @param name the new name to affect
     * @param age the new age to affect
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public void setTeacher(int code, int code2, String name, int age) throws ExceptionUniversity;

    /**
     * 
     * @param code the code of teacher
     * @return the teacher having the code in param
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public Teacher getTeacher(int code) throws ExceptionUniversity;

    public Teacher getTeacher(String name) throws ExceptionUniversity ;
    /**
     * 
     * @param code code of the teacher
     * @return true if the associated teacher to the code is in the Collection Of Teachers
     */
    public boolean isExist(int code);

    /**
     * 
     * @param code delete the teacher having thye associated code
     * @throws myuniversityproject20082009.ExceptionUniversity if the teacher having the code doesn't exist
     */
    public void delete(int code) throws ExceptionUniversity;

    /**
     * 
     * @return the Collection Of Teachers as String
     */
    @Override
    public String toString();
}
