/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package myuniversityproject20082009;

/**
 *
 * @author CHIHAOUI
 */
public class Students extends java.util.TreeSet<Student> implements InterfaceStudents, java.io.Serializable {
    
    
    public Students(){
        super();
    }
    /**
     * 
     * @return the number of student in the List Of Students
     */
    public int getSize() {
        return super.size();
    }

    /**
     * 
     * @return true if the List Of Students is empty, false if not
     */
    @Override
    public boolean isEmpty() {
        return super.isEmpty();
    }

    /**
     * 
     * @param student add student to the List Of Students
     */
    public boolean addStudent(Student student) {
        return super.add(student);
    }
    /**
     * 
     * @param code the code of student
     * @return the student having the code in param
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public Student getStudent(int code) throws ExceptionUniversity {
        java.util.Iterator i = this.iterator();
        while (i.hasNext()) {
            Student student = (Student) i.next();
            if (student.getCode() == code) {
                return student;
            }
        }
        throw new ExceptionUniversity("The Code Is Invalid");
    }

    public Student getStudent(String name) throws ExceptionUniversity {
        java.util.Iterator i = this.iterator();
        while (i.hasNext()) {
            Student student = (Student) i.next();
            if (student.getName().equalsIgnoreCase(name)) {
                return student;
            }
        }
        throw new ExceptionUniversity("The Name Is Invalid");
    }
    
    /**
     * 
     * @param code the code of student to search for
     * @param code2 the new code to affect
     * @param name the new name to affect
     * @param age the new age to affect
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public void setStudent(int code, int code2, String name, int age) throws ExceptionUniversity {
        java.util.Iterator i = super.iterator();
        boolean find = false;
        Student student = null;
        while ((i.hasNext()) && (!find)) {
            student = (Student) i.next();
            if (student.getCode() == code) {
                find = true;
            }
        }
        if (find) {
            student.setName(name);
            student.setAge(age);
            student.setCode(code2);
        } else {
            throw new ExceptionUniversity("The Code Is Invalid");
        }
    }

    /**
     * 
     * @param code code of the student
     * @return true if the associated student to the code is in the List Of Students
     */
    public boolean isExist(int code) {
        java.util.Iterator i = super.iterator();
        boolean find = false;
        while ((i.hasNext()) && (!find)) {
            Student student = (Student) i.next();
            if (student.getCode() == code) {
                find = true;
            }
        }
        if (!find) {
            return false;
        } else {
            return true;
        }
    }

    /**
     * 
     * @param code delete the student having thye associated code
     * @throws myuniversityproject20082009.ExceptionUniversity if the student having the code doesn't exist
     */
    public void delete(int code) throws ExceptionUniversity {
        java.util.Iterator i = super.iterator();
        boolean find = false;
        Student student;
        while ((i.hasNext()) && (!find)) {
            student = (Student) i.next();
            if (student.getCode() == code) {
                find = true;
            }
        }
        if (find) {
            i.remove();
        } else {
            throw new ExceptionUniversity("The Code Is Invalid");
        }
    }

    /**
     * 
     * @return the List Of Students as String
     */
    @Override
    public String toString() {
        String ch="";
        java.util.Iterator i = super.iterator();
        Student student;
        while (i.hasNext()) {
            student = (Student) i.next();
            ch=ch+" "+student;
        }
        return ch;
    }
}
