/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package myuniversityproject20082009;

/**
 *
 * @author CHIHAOUI
 */
public class Teacher extends Person implements InterfaceTeacher,java.io.Serializable{

    private InterfaceInstitute institute;
    
    /**
     * create new Teacher
     * @param code code of the Teacher as Integer
     * @param name name of the Teacher as String
     */
    public Teacher(int code,String name,int age){
        super(code,name,age);
    }
    
    /**
     * create new Teacher
     * @param code code of the Teacher as Integer
     * @param name name of the Teacher as String
     */
    public Teacher(int code,String name,int age,InterfaceInstitute institute){
        super(code,name,age);
        this.institute=institute;
    }
    
    /**
     * 
     * @return the name of this institute
     */
    public String getInstituteName(){
        return this.institute.getName();
    }
    
    /**
     * 
     * @return the code of the institute
     */
    public int getInstituteCode(){
        return this.institute.getCode();
    }
    
    /**
     * 
     * @param name the new name to affect
     */
    public void setInstituteName(String name){
       this.institute.setName(name);
    }
    
    /**
     * the new code to set
     * @param code
     */
    public void setInstituteCode(int code){
       this.institute.setCode(code);
    }
    /**
     * 
     * @return the object as String
     */
    @Override
    public String toString(){
        return "The Teacher : "+super.getName()+" his code : "+super.getCode();
    }
    
    /**
     * 
     * @return the function of the person
     */
    public String getFunction(){
        return "Teacher";
    }
}
